package inf112.skeleton.app;

import javafx.scene.paint.Paint;

public class Enemy implements IGameObject{
    int x, y, w, h, distance;
    int walkSpeed = 1;
    int sum = 0;
    private int gravity = 5;
    Paint color;
    boolean canMoveDown = true;
    String direction = "right";

    public Enemy(int X, int Y, int W, int H, Paint color, int distance) {
        this.x = X;
        this.y = Y;
        this.w = W;
        this.h = H;
        this.color = color;
        this.distance = distance;
    }

    @Override
    public int getHeight() {
        return this.h;
    }

    @Override
    public int getWidth() {
        return this.w;
    }

    @Override
    public int getX() {
        return this.x;
    }

    @Override
    public int getY() {
        return this.y;
    }

    @Override
    public int getSpeed() {
        return this.walkSpeed;
    }

    @Override
    public int getGravity() {
        return this.gravity;
    }

    public Paint getColor() {
        return this.color;
    }

    public void walk() {
        if(direction == "right") {
            this.x += walkSpeed;
            sum += walkSpeed;
        }
        else {
            this.x -= walkSpeed;
            sum -= walkSpeed;
        }

        if (sum >= distance) direction = "left";

        else if (sum < 0) direction = "right";

        if (canMoveDown) {
            this.y += gravity;
        }
    }
}
